﻿using UnityEngine;
using System.Collections;

// http://answers.unity3d.com/questions/38526/smooth-follow-camera.html
using UnityEditor;

public class CameraFollowing : MonoBehaviour
{
	public GameObject target;

	// Use this for initialization
	void Start ()
	{

	}

	void Update ()
	{
		Vector3 currentVelocity = Vector3.zero;

		Vector3 forward = target.transform.forward * 10f + target.transform.up * -5f;
		Vector3 needPos = target.transform.position - forward;

		// カメラをSmoothDampでスムーズに移動
		transform.position = Vector3.SmoothDamp (transform.position, needPos, ref currentVelocity, 0.05f);

		// 対象にカメラを向ける
		//transform.LookAt (target.transform);
		//transform.rotation = target.transform.rotation;

		//Vector3 wMousePosition = Camera.main.ScreenToWorldPoint (Input.mousePosition);
		//transform.LookAt (wMousePosition, new Vector3 (0, 0, -1));

		var ray = Camera.main.ScreenPointToRay (Input.mousePosition);
		Plane plane = new Plane (Vector3.up, Vector3.zero);
		float hitDistance;
		if (plane.Raycast (ray, out hitDistance)) {
			Vector3 targetPoint = ray.GetPoint (hitDistance);

			Quaternion targetRotation = Quaternion.LookRotation (targetPoint - transform.position);

			// Smooth
			float speed = 1f;
			transform.rotation = Quaternion.Slerp (transform.rotation, targetRotation, speed * Time.deltaTime);
		}

	}
}
