﻿using UnityEngine;
using System.Collections;

public class FloatingTextController : MonoBehaviour
{
	private static FloatingText popupTextPrefab;
	private static GameObject canvas;

	public static void Initialize ()
	{
		Debug.Log ("Initialize");
		canvas = GameObject.Find ("Canvas");
		if (!popupTextPrefab) {
			popupTextPrefab = Resources.Load<FloatingText> ("Prefabs/PopupTextParent");
		}
	}

	public static void CreateFloatingText (string text, Transform textTransform)
	{
		FloatingText instance = Instantiate (popupTextPrefab) as FloatingText;
		bool worldPositionStays = false;

		// ワールド空間の position をスクリーン空間に変換。
		Vector2 screenPosition = Camera.main.WorldToScreenPoint (textTransform.position);
		//Vector2 randomPosition = new Vector2 (textTransform.position.x + Random.Range (-.1f, .1f), textTransform.position.y + Random.Range (-.1f, .1f));
		//Vector2 screenPosition = Camera.main.WorldToScreenPoint (randomPosition);

		instance.transform.SetParent (canvas.transform, worldPositionStays);
		instance.transform.position = screenPosition;
		instance.SetText (text);
	}
}
