﻿using UnityEngine;
using System.Collections;

public class Player : MonoBehaviour
{
	public float moveSpeed = 1f;
	Vector3 force;
	Rigidbody rb;

	// Use this for initialization
	void Start ()
	{
		rb = GetComponent<Rigidbody> ();
	}
	
	// Update is called once per frame
	void Update ()
	{
		force = new Vector3 (Input.GetAxis ("Horizontal"), 0f, Input.GetAxis ("Vertical")) * moveSpeed;
		/*
		// カメラからマウス座標の光線
		Ray ray = Camera.main.ScreenPointToRay (Input.mousePosition);
		Plane tmpPlane = new Plane (Vector3.up, Vector3.zero); // 原点を通るXZ座標の面。
		float rayDistance;
		if (tmpPlane.Raycast (ray, out rayDistance)) {
			Debug.Log ("Hit!!");
			Vector3 point = ray.GetPoint (rayDistance);
			transform.LookAt (point);
		}
		*/
		var ray = Camera.main.ScreenPointToRay (Input.mousePosition);
		Plane plane = new Plane (Vector3.up, Vector3.zero);
		float hitDistance;
		if (plane.Raycast (ray, out hitDistance)) {
			Vector3 targetPoint = ray.GetPoint (hitDistance);

			Quaternion targetRotation = Quaternion.LookRotation (targetPoint - transform.position);

			// Smooth
			float speed = 1f;
			transform.rotation = Quaternion.Slerp (transform.rotation, targetRotation, speed * Time.deltaTime);
		}
	}

	void FixedUpdate ()
	{
		rb.AddForce (force, ForceMode.Impulse);
	}
}
